program TestIntHeap;
  {-Example program to test the TIntHeap}

uses
  EZIntQue;

var
  StartMem : longint;
  i   : integer;
  Que : TIntHeap;
  L   : longint;

begin
  {get the initial memory available}
  StartMem := MemAvail;

  {initialise the queue to be a maxheap}
  writeln('MaxHeap test...');
  if not Que.Init(true) then
    begin
      writeln('Error during max heap Init');
      Halt;
    end;
  Randomize;

  {add some longints onto the queue}
  for i := 1 to 100 do
    begin
      L := random(64000);
      Que.Add(L);
    end;

  {pop the 1st 10 longints off in ascending order, and write them out}
  for i := 1 to 10 do
    writeln(Que.Pop);

  {destroy the max heap}
  Que.Done;

  {initialise the queue to be a minheap}
  writeln('MinHeap test...');
  if not Que.Init(false) then
    begin
      writeln('Error during min heap Init');
      Halt;
    end;
  Randomize;

  {add some longints onto the queue}
  for i := 1 to 100 do
    begin
      L := random(64000);
      Que.Add(L);
    end;

  {pop the 1st 10 longints off in descending order, and write them out}
  for i := 1 to 10 do
    writeln(Que.Pop);

  {destroy the min heap}
  Que.Done;

  {check that all the memory was released}
  if (MemAvail <> StartMem) then
    writeln('Warning: memory left allocated on the heap');
end.
